//
// Copyright (C) 2006 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file VastDefs.cc
 * @author Helge Backhaus
 */

#include "VastDefs.h"

Site::Site()
{
    type = UNDEF;
    innerEdge[0] = false;
    innerEdge[1] = false;
    innerEdge[2] = false;
    outerEdge = false;
    isAdded = false;
    addr = NodeHandle::UNSPECIFIED_NODE;
    tstamp = 0.0;
}

std::ostream& operator<<(std::ostream& Stream, const Site s)
{
    Stream  << "Type: ";
    if(s.type & UNDEF) Stream << "Undefined ";
    if(s.type & THIS) Stream << "This ";
    if(s.type & ENCLOSING) Stream << "Enclosing ";
    if(s.type & NEIGHBOR) Stream << "Inner ";
    if(s.type & BOUNDARY) Stream << "Boundary ";
    if(s.type & NEW) Stream << "Discovered ";
    return Stream << "  IP: " << s.addr.ip;
}

Edge::Edge()
{
    a = 0.0;
    b = 0.0;
    c = 0.0;
    ep[0] = NULL;
    ep[1] = NULL;
    reg[0] = NULL;
    reg[1] = NULL;
}

Halfedge::Halfedge()
{
    ELleft = NULL;
    ELright = NULL;
    ELedge = NULL;
    ELpm = 0;
    vertex = NULL;
    ystar = 0.0;
    PQnext = NULL;
}
